<?xml version="1.0"?>
<!-- 
	XSLT transform for Correlator Debugger pages.
	$Copyright(c) 2009-2010, 2012 Progress Software Corporation (PSC). All rights reserved.$ 
	$Copyright (c) 2013, 2017 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$ 
	Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG 
-->
<xsl:stylesheet 
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
   version="1.0"
   >
<xsl:output method="html" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" />

<xsl:template match="/">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
 <head>
	<title>Apama</title>
	<link rel="stylesheet" type="text/css" href="/resources/apama.css" />
	<link rel="stylesheet" type="text/css" href="/resources/debugger.css" />
	<script language="javascript" type="text/javascript" src="/resources/xhr_props.js"><xsl:comment></xsl:comment></script>
	<script language="javascript" type="text/javascript" src="/resources/breadcrumbs.js"><xsl:comment></xsl:comment></script>
	<script language="javascript" type="text/javascript" src="/resources/methods.js"><xsl:comment></xsl:comment></script>
	<script language="javascript" type="text/javascript" src="/resources/jquery.js"><xsl:comment></xsl:comment></script>
	<script language="javascript" type="text/javascript" src="/resources/debugger.js"><xsl:comment></xsl:comment></script>
	<script language="javascript" type="text/javascript" src="/resources/edit_area_full.gz"><xsl:comment></xsl:comment></script>
 </head>
 <body>
 	<div class='masthead'><img src="/resources/images/product_logo.png" alt="Apama" /></div>
	<div class='content'>
		<div id="componentName">
			<script language="javascript">getComponentInfo(document.location);</script>
		</div>
		<h2>EPL inspection/debugging</h2>
		<div id="breadcrumbs"><script language="javascript">breadcrumbs();</script></div>
		<xsl:apply-templates select="*"/>
	</div>
	<div class="footer"><span class="footer-txt">Copyright (c) 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.</span><img src="/resources/images/sag-footer.png" alt="Logo" /></div>
 </body>
</html>
</xsl:template>

<xsl:template match="prop[@name='filename']">
<h2><xsl:value-of select="." /></h2>
</xsl:template>
<xsl:template match="prop[@name='lines']"></xsl:template>
<xsl:template match="prop[@name='filehash']"></xsl:template>


<xsl:template match="prop[@name='error']">
<h4>An error occurred</h4>
<pre>
<xsl:value-of select="." />
</pre>
</xsl:template>

<xsl:template match="prop[@name='type']">
<xsl:choose>
<xsl:when test=". = 'input'">
	<script language="javascript" type="text/javascript">
		function ealoadcallback(id) { }
		makeEditor("codeView", true);
	</script>
<textarea id="codeView" style='width: 100%;' rows="30">
</textarea>
<div>Inject new file into the correlator: <input type='button' value='Inject' id='button_inject_id' onClick='compile("codeView", false)' style='text-weight: bold;'/></div>
<h4 id="codeLink"></h4>
<form method='post' enctype='multipart/form-data' action='/correlator/code/inject'><div>Upload and inject EPL from file/CDP: <input type='file' name='file'/> <input type='submit' value='Inject' /></div></form>
<h2>Warnings/Errors</h2>
<textarea cols='100' rows='5' id="compilationMessages">
</textarea>
</xsl:when>
<xsl:when test=". = 'code'">
	<script language="javascript" type="text/javascript">
		function ealoadcallback(id) {
			line = "<xsl:value-of select="/map[@name='apama-response']/prop[@name='lines']/." />";
			if (line) window.frames["frame_"+id].editArea.go_to_line(line);
		}
		loadCode("codeView", "/correlator/code/hash/raw/<xsl:value-of select="/map[@name='apama-response']/prop[@name='filehash']/."/>");
	</script>
<textarea id="codeView" style='width: 100%;' rows="30">
</textarea>
<div>Delete and re-inject: 
	<input type='button' value='Delete' id='button_unject_id' style='text-weight: bold;'><xsl:attribute name='onClick'>deleteall("<xsl:value-of select="/map[@name='apama-response']/prop[@name='filehash']/."/>", null, "");</xsl:attribute></input>
	<input type='button' value='Inject' id='button_reinject_id' onClick='compile("codeView", true)' style='text-weight: bold; margin-left: 15px;'/>
</div>
<h2>Warnings/Errors</h2>
<textarea cols='100' rows='5' id="compilationMessages">
</textarea>
</xsl:when>
  <xsl:otherwise>
<p>Download the code: <a><xsl:attribute name='href'><xsl:value-of select="/map[@name='apama-response']/prop[@name='filehash']/."/></xsl:attribute><xsl:value-of select="/map[@name='apama-response']/prop[@name='filename']/."/></a></p>
</xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template match="list[@name='breakpoints']">
<h3>Breakpoints</h3>
<form name="breakon">
<table>
<tr><td><b>Break on errors</b></td><td id='breakOnErrors' />
<script>makeToggleButton('breakOnErrors', '/correlator/debug/breakpoint/errors', 'breakonerrors'); </script></tr>
<!--tr><td><b>Break on all events</b></td><td id='breakOnAllEvents'/>
<script>makeToggleButton('breakOnAllEvents', '/correlator/debug/breakpoint/all-events', 'breakonallevents');</script></tr-->
<!--tr><td><b>Break on monitor entry</b></td><td id='breakOnMonitorEntry' />
<script>makeToggleButton('breakOnMonitorEntry', '/correlator/debug/breakpoint/monitor-entry', 'breakonmonitorentry');</script></tr-->
</table>
</form>

<table><xsl:attribute name="class"><xsl:value-of select="@name" /> tableApamaResponse</xsl:attribute>
<thead>
<tr><th>Id</th><th>Owner</th><th>Action</th><th>File</th><th>Line</th><th>Single-use</th><th>Delete</th></tr>
</thead>
<tbody>
<xsl:for-each select="map">
<tr>
	<xsl:if test="position() mod 2 = 1">
		<xsl:attribute name="class">odd</xsl:attribute>
	</xsl:if>
	<td><xsl:value-of select="prop[@name='id']/text()" /></td>
	<td><xsl:value-of select="prop[@name='owner']/text()" /></td>
	<td><xsl:value-of select="prop[@name='action']/text()" /></td>
	<td><a><xsl:attribute name='href'>/correlator/code/hash/<xsl:value-of select="prop[@name='filehash']/text()" />/<xsl:value-of select="prop[@name='line']/text()" /></xsl:attribute>
	<xsl:value-of select="prop[@name='filename']/text()" /></a></td>
	<td><a><xsl:attribute name='href'>/correlator/code/hash/<xsl:value-of select="prop[@name='filehash']/text()" />/<xsl:value-of select="prop[@name='line']/text()" /></xsl:attribute>
	<xsl:value-of select="prop[@name='line']/text()" /></a></td>
	<td><xsl:value-of select="prop[@name='breakonce']/text()" /></td>
	<td><input type='button' value='Delete' id='dbpbutton' name='delete'>
	<xsl:attribute name="onclick">del('/correlator/debug/breakpoint/location/<xsl:value-of select="prop[@name='id']/text()" />');</xsl:attribute></input></td>
</tr>
</xsl:for-each>
</tbody>
</table>
<form name='addbreak'>
<table class='input'>
<tbody>
<tr><td>Owner:</td><td><input type='text' name='owner' /></td>
    <td>Action:</td><td><input type='text' name='action'  /></td>
	 <td>Line:</td><td><input type='text' size='4' name='actionline' /></td>
	 <td>Once:</td><td><input type='checkbox' name='actiononce' /></td>
	 <td><input type='button' id='dbpbutton' value='Add Breakpoint' name='addaction' onclick='addactionbreak();' /></td></tr>
<tr><td>Filename:</td><td colspan='3'><input type='text' name='filename' size='50' /></td>
	 <td>Line:</td><td><input type='text' name='fileline' size='4' /></td>
	 <td>Once:</td><td><input type='checkbox' name='fileonce' /></td>
	 <td><input type='button' id='dbpbutton' value='Add Breakpoint' name='addfile' onclick='addfilebreak();'  /></td></tr>
<tr><td>Hash:</td><td colspan='3'><input type='text' name='hash' size='50' /></td>
	 <td>Line:</td><td><input type='text' name='hashline' size='4' /></td>
	 <td>Once:</td><td><input type='checkbox' name='hashonce' /></td>
	 <td><input type='button' id='dbpbutton' value='Add Breakpoint' name='addhash' onclick='addhashbreak();'  /></td></tr>
</tbody>
</table>
</form>
</xsl:template>

<xsl:template match="list[@name='progress']">
<h3>Send commands</h3>
<table class='input'>
<tr>
<td><input type='button' id='dbpbutton' name='stop' value='Stop' onclick="put('/correlator/debug/progress/stop');" /></td>
<td><input type='button' id='dbpbutton' name='resume' value='Resume' onclick="put('/correlator/debug/progress/run');" /></td>
<td><input type='button' id='dbpbutton' name='step' value='Step In' onclick="put('/correlator/debug/progress/step');" /></td>
<td><input type='button' id='dbpbutton' name='stepover' value='Step Over' onclick="put('/correlator/debug/progress/stepover');" /></td>
<td><input type='button' id='dbpbutton' name='stepout' value='Step Out' onclick="put('/correlator/debug/progress/stepout');" /></td>
</tr>
<tr>
	<th colspan='5'><a href="/correlator/debug/progress/wait">Wait for suspension</a></th>
</tr>
</table>
<h3>Current progress</h3>
<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="map[@name='contextprogress']">
<xsl:variable name="contextid"><xsl:value-of select="prop[@name='contextid']/text()" /></xsl:variable>
<xsl:variable name="paused"><xsl:value-of select="prop[@name='paused']/text()" /></xsl:variable>
<table><xsl:attribute name="class"><xsl:value-of select="@name" /> tableApamaResponse</xsl:attribute>
<thead>
<tr><th></th><th>Name</th><th>Id</th></tr>
<tr><td>Context</td>
<td><a>
	<xsl:attribute name="href">/correlator/contexts/id:<xsl:value-of select="$contextid" />/</xsl:attribute>
	<xsl:value-of select="prop[@name='context']/text()" /></a></td>
<td><a>
	<xsl:attribute name="href">/correlator/contexts/id:<xsl:value-of select="$contextid" />/</xsl:attribute>
	<xsl:value-of select="prop[@name='contextid']/text()" /></a>
</td></tr>
<tr><td>Monitor</td>
<td><a>
	<xsl:attribute name="href">/correlator/contexts/id:<xsl:value-of select="$contextid" />/<xsl:value-of select="prop[@name='instance']/text()" />/</xsl:attribute>
	<xsl:value-of select="prop[@name='monitor']/text()" /></a></td>
<td><a>
	<xsl:attribute name="href">/correlator/contexts/id:<xsl:value-of select="$contextid" />/<xsl:value-of select="prop[@name='instance']/text()" />/</xsl:attribute>
	<xsl:value-of select="prop[@name='instance']/text()" /></a>
</td></tr>
</thead>
<tbody>
<xsl:if test="$paused='true'">
<tr>
	<xsl:if test="position() mod 2 = 1">
		<xsl:attribute name="class">odd</xsl:attribute>
	</xsl:if>
	<td colspan='3' style='text-align: center'>
		<a>
			<xsl:attribute name="href">stack/id:<xsl:value-of select="$contextid" /></xsl:attribute>
			Stack Trace
		</a>
	</td>
</tr>
</xsl:if>
<tr class='odd'>
	<td>Paused:</td><td colspan='2'><xsl:value-of select="prop[@name='paused']/text()" /></td>
</tr>
<xsl:if test="$paused='true'">
	<tr>
		<td>Owner:</td><td colspan='2'>
		<xsl:value-of select="prop[@name='type']/text()" />
		<xsl:text> </xsl:text>
		<xsl:value-of select="prop[@name='owner']/text()" /></td>
	</tr>
	<tr class='odd'>
		<td>Action:</td><td colspan='2'><xsl:value-of select="prop[@name='action']/text()" /></td>
	</tr>
	<tr>
		<td>Filename:</td><td colspan='2'>
		<a><xsl:attribute name='href'>/correlator/code/hash/<xsl:value-of select="prop[@name='filehash']/text()" />/<xsl:value-of select="prop[@name='line']/text()" /></xsl:attribute>
		<xsl:value-of select="prop[@name='filename']/text()" /></a></td>
	</tr>
	<tr class='odd'>
		<td>Line:</td><td colspan='2'>
		<a><xsl:attribute name='href'>/correlator/code/hash/<xsl:value-of select="prop[@name='filehash']/text()" />/<xsl:value-of select="prop[@name='line']/text()" /></xsl:attribute>
		<xsl:value-of select="prop[@name='line']/text()" /></a></td>
	</tr>
	<tr>
		<td>Cause:</td><td colspan='2'><xsl:value-of select="prop[@name='reason']/text()" /></td>
	</tr>
</xsl:if>
</tbody>
</table>
</xsl:template>


<xsl:template match="map[@name='context']">
<xsl:variable name="contextid"><xsl:value-of select="prop[@name='contextid']/text()" /></xsl:variable>
<table><xsl:attribute name="class"><xsl:value-of select="@name" /> tableApamaResponse</xsl:attribute>
<thead>
<tr><th></th><th colspan='2'>Name</th><th>Id</th></tr>
<tr><td>Context</td>
<td colspan='2'><xsl:value-of select="prop[@name='context']/text()" /></td>
<td><xsl:value-of select="prop[@name='contextid']/text()" /></td></tr>
</thead>
<tbody>
<tr><td rowspan="100000000">MThreads</td><th>Monitor</th><th>Filename</th><th>Id</th></tr>
<xsl:for-each select="list/map">
<tr>
	<xsl:if test="position() mod 2 = 1">
		<xsl:attribute name="class">odd</xsl:attribute>
	</xsl:if>
	<td><a>
	<xsl:attribute name="href">/correlator/contexts/id:<xsl:value-of select="$contextid" />/<xsl:value-of select="prop[@name='id']/text()" />/</xsl:attribute>
	<xsl:value-of select="prop[@name='type']/text()" /></a></td>
	<td>
	<a><xsl:attribute name='href'>/correlator/code/hash/<xsl:value-of select="prop[@name='filehash']/text()" /></xsl:attribute>
	<xsl:value-of select="prop[@name='filename']/text()" /></a></td>
	<td><xsl:value-of select="prop[@name='id']/text()" /></td>
</tr>
</xsl:for-each>
</tbody>
</table>
</xsl:template>

<xsl:template match="list[@name='names']">
<h3>Names declared in file <xsl:value-of select="prop[@name='filename']/text()" /></h3>
<table class='tableApamaResponse value'>
<thead>
<tr><th>Type</th><th>Name</th><th>Delete</th></tr>
</thead>
<tbody>
<xsl:for-each select="map">
<tr>
	<xsl:attribute name="id"><xsl:value-of select="prop[@name='name']/text()" /></xsl:attribute>
	<td><xsl:value-of select="prop[@name='type']/text()" /></td>
	<td><xsl:value-of select="prop[@name='name']/text()" /></td>
	<td><input type="button" id="dbpbutton" value="Delete"><xsl:attribute name="onClick">deleteName("<xsl:value-of select="prop[@name='name']/text()" />", deleterow, "<xsl:value-of select="prop[@name='name']/text()" />")</xsl:attribute></input></td>
</tr>
</xsl:for-each>
</tbody>
</table>
<pre id="compilationMessages"></pre>
</xsl:template>

<xsl:template match="list[@name='locals']">
<xsl:variable name="contextid"><xsl:value-of select="prop[@name='contextid']/text()" /></xsl:variable>
<h3>Local Variables (<span id='idspan'><script language="javascript">id();</script></span>)</h3>
<xsl:for-each select="map">
<table class='tableApamaResponse value'>
<thead>
<tr><th><xsl:value-of select="prop[@name='type']/text()" /><xsl:text> </xsl:text><xsl:value-of select="prop[@name='name']/text()" /> :=</th></tr>
</thead>
<tbody>
<tr><td><tt>
<xsl:value-of select="prop[@name='value']/text()" />
</tt></td></tr>
</tbody>
</table>
</xsl:for-each>
</xsl:template>

<xsl:template match="list[@name='stack']">
<xsl:variable name="contextid"><xsl:value-of select="prop[@name='contextid']/text()" /></xsl:variable>
<xsl:variable name="monitor"><xsl:value-of select="prop[@name='monitor']/text()" /></xsl:variable>
<xsl:variable name="mthreadid"><xsl:value-of select="prop[@name='mthreadid']/text()" /></xsl:variable>
<table class='stack tableApamaResponse'>
<thead>
<tr><th colspan='4'>Stack trace for context <xsl:value-of select="$contextid"/>, 
	monitor <xsl:value-of select="$monitor"/>,
	instance <xsl:value-of select="$mthreadid"/></th></tr>
<tr><th>Owner</th><th>Action</th><th>Location</th><th>Locals</th></tr>
</thead>
<tbody>
<xsl:for-each select="map">
<tr>
	<xsl:if test="position() mod 2 = 1">
		<xsl:attribute name="class">odd</xsl:attribute>
	</xsl:if>
	<td><xsl:value-of select="prop[@name='type']/text()" /><xsl:text> </xsl:text><xsl:value-of select="prop[@name='owner']/text()" /></td>
	<td><xsl:value-of select="prop[@name='action']/text()" />()</td>
	<td>
	<a><xsl:attribute name='href'>/correlator/code/hash/<xsl:value-of select="prop[@name='filehash']/text()" />/<xsl:value-of select="prop[@name='lineno']/text()" /></xsl:attribute>
	<xsl:value-of select="prop[@name='filename']/text()" />:<xsl:value-of select="prop[@name='lineno']/text()" /></a></td>
	<td><a>
		<xsl:attribute name="href">/correlator/debug/progress/locals/id:<xsl:value-of select="$contextid"/>;<xsl:value-of select="position()-1"/></xsl:attribute>
	Locals</a></td>
</tr>
</xsl:for-each>
</tbody>
</table>
</xsl:template>


<xsl:template match="list[@name='mthread']">
<h3>Contents of mThread id <span id='idspan'><script language="javascript">id();</script></span></h3>
<table class='mthread tableApamaResponse'>
<thead>
<tr><th>Type</th><th>Name</th><!--th>Size</th--></tr>
</thead>
<tbody>
<xsl:for-each select="map">
<tr>
	<xsl:if test="position() mod 2 = 1">
		<xsl:attribute name="class">odd</xsl:attribute>
	</xsl:if>
	<td><xsl:value-of select="prop[@name='type']/text()" /></td>
	<td><a>
	<xsl:attribute name="href"><xsl:value-of select="prop[@name='name']/text()" /></xsl:attribute>
	<xsl:value-of select="prop[@name='name']/text()" /></a></td>
	<!-- not yet implemented td><xsl:value-of select="prop[@name='size']/text()" /></td-->
</tr>
</xsl:for-each>
</tbody>
</table>
</xsl:template>

<xsl:template match="prop[@name='reason']">
<table class='contextprogress tableApamaResponse'>
<thead>
<tr><th colspan="2">Correlator Stopped</th></tr>
</thead>
<tbody>
<tr><td>Cause</td><td><xsl:value-of select="." /></td></tr>
</tbody>
</table>
</xsl:template>


<xsl:template match="prop[@name='value']">
<table class='tableApamaResponse value'>
<thead>
<tr><th>Value of variable <span id='idspan'><script language="javascript">id();</script></span></th></tr>
</thead>
<tbody>
<tr><td><tt>
	<xsl:value-of select="text()" />
</tt></td></tr>
</tbody>
</table>
</xsl:template>


<xsl:template match="prop[@name='debug']">
<p>
	Debugging is currently 
<xsl:if test="text()='true'" >
<span style='color: red; font-weight: bold;'>enabled</span>.
<input type='button' value='Disable Debugging' onclick="del('/correlator/debug/state');" id='debug_disable' />
</xsl:if>
<xsl:if test="text()='false'">
<span style='color: green;'>disabled</span>.
<input type='button' value='Enable Debugging' onclick="put('/correlator/debug/state');" id='debug_enable' />
</xsl:if>
</p>
<h3>Tasks</h3>
<ul>
<li><a href="/correlator/contexts">Inspect Global State</a></li>
<li><a href="/correlator/debug/breakpoint">View/Edit Breakpoints</a></li>
<li><a href="/correlator/debug/progress">View/Control Context Progress</a></li>
<li><a href="/correlator/code/list">Show Injected Files</a></li>
<li><a href="/correlator/code/inject">Inject New File</a></li>
</ul>
</xsl:template>


<xsl:template match="list[@name='files']">
<h3>List of injected files</h3>
<table class='tableApamaResponse'>
<thead>
<tr><th>Filename</th><th>Hash</th><th>Size</th><th>Delete</th></tr>
</thead>
<tbody>
<xsl:for-each select="map">
<tr>
   <xsl:attribute name="id">
	  <xsl:value-of select="prop[@name='filehash']/text()" />
	</xsl:attribute>
	<xsl:if test="position() mod 2 = 1">
		<xsl:attribute name="class">odd</xsl:attribute>
	</xsl:if>
	<td><a><xsl:attribute name="href">/correlator/code/hash/list/<xsl:value-of select="prop[@name='filehash']/text()" /></xsl:attribute><xsl:value-of select="prop[@name='filename']/text()" /></a></td>
	<td><a><xsl:attribute name="href">/correlator/code/hash/<xsl:value-of select="prop[@name='filehash']/text()" /></xsl:attribute><xsl:value-of select="prop[@name='filehash']/text()" /></a></td>
	<td><xsl:value-of select="prop[@name='filesize']/text()" /></td>
	<td><input type="button" id='dbpbutton' value="Delete"><xsl:attribute name="onClick">deleteall("<xsl:value-of select="prop[@name='filehash']/text()" />", deleterow, "<xsl:value-of select="prop[@name='filehash']/text()" />")</xsl:attribute></input></td>
</tr>
</xsl:for-each>
</tbody>
</table>
<pre id="compilationMessages"></pre>
</xsl:template>



<xsl:template match="map[@name='apama-exception']">
<h3><xsl:value-of select="prop[@name='statuscode']/text()" /> -
<xsl:value-of select="prop[@name='statusstring']/text()" /></h3>
<p>An error occured while processing your request. 
Either it is not possible to satisfy your request, or you may need to retry.</p>
</xsl:template>


<xsl:template match="*">
 <xsl:apply-templates select="*"/>
</xsl:template>

</xsl:stylesheet>

